/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

package com.carlosbcruz.controller;

import com.carlosbcruz.bruteforce.BruteForce;
import com.carlosbcruz.pegsolitaire.CommandOnlyOneEvent;
import com.carlosbcruz.pegsolitaire.OnlyOneGUI;
import com.carlosbcruz.pegsolitaire.OnlyOneGUIAdapter;


/**
 * Link the brute force algorithm to the gui control
 *
 * @author Carlos Fernando Bella Cruz - <a href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class OnlyOneTranslator {

    // Brute force generic algorithm
    private BruteForce bf = null;
    // Gui to control the application
    private OnlyOneGUI gui = null;

    /**
     * Constructor that link the brute force algorithmwith the interface
     * @param gui the gui control
     * @param bf the brute force algorithm
     */
    public OnlyOneTranslator(OnlyOneGUI gui, BruteForce bf) {

        this.gui = gui;
        this.bf = bf;

        // Link the two possible action, start and stop.
        gui.addOnlyOneGUIStartListener(new StartAdapter());
        gui.addOnlyOneGUIStopListener(new StopAdapter());

    }

    /**
     * Control the start of the algorithm 
     * 
     * @author Carlos Fernando Bella Cruz - <a href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
     */
    public class StartAdapter extends OnlyOneGUIAdapter {

        /* (non-Javadoc)
         * @see onlyoneproblem.OnlyOneGUIAdapter#start(onlyoneproblem.CommandOnlyOneEvent)
         */
        public void start(CommandOnlyOneEvent e) {

            bf.execute();
        }
    }

    /**
     * Control the stop of the algorithm 
     * 
     * @author Carlos Fernando Bella Cruz - <a href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
     */
    public class StopAdapter extends OnlyOneGUIAdapter {

        /* (non-Javadoc)
         * @see onlyoneproblem.OnlyOneGUIAdapter#stop(onlyoneproblem.CommandOnlyOneEvent)
         */
        public void stop(CommandOnlyOneEvent e) {

            bf.stop();
        }
    }
}
